#!/usr/bin/perl

# copyright Martin Pot 2003
# http://martybugs.net/linux/rrdtool/traffic.cgi
#
# Adapted by Michael Hanson 2011 <hansonorders@verizon.net>
#

my @graphs;
my ($name, $descr);

# define graphs to display (add/remove as required)
push (@graphs, "network");
push (@graphs, "cpu");
#push (@graphs, "fans");
#push (@graphs, "hddtemp");
push (@graphs, "memory");
#push (@graphs, "ups");
#push (@graphs, "system");
#push (@graphs, "voltages");
#push (@graphs, "usage-boot");
#push (@graphs, "usage-home");
#push (@graphs, "usage-mysql");
#push (@graphs, "usage-mythtv");
#push (@graphs, "usage-rootfs");
#push (@graphs, "activity-OS_Drive");
#push (@graphs, "activity-MythTV_Drive");

# get the server name (or you could hard code some description here)
#my $svrname = $ENV{'SERVER_NAME'};
my $svrname = 'my_host';
my $img_path = '/rrd';

# get url parameters
my @values = split(/&/, $ENV{'QUERY_STRING'});
foreach my $i (@values)
{
	($varname, $mydata) = split(/=/, $i);
	if ($varname eq 'trend')
	{
		$name = $mydata;
	}
}

if ($name eq '')
{
	$descr = "summary";
}
else
{
	$descr = "$name";
}

print "Content-type: text/html;\n\n";
print <<END
<html>
<head>
  <TITLE>$svrname RRD Statistics :: $descr</TITLE>
  <META HTTP-EQUIV="Refresh" CONTENT="300">
  <META HTTP-EQUIV="Cache-Control" content="no-cache">
  <META HTTP-EQUIV="Pragma" CONTENT="no-cache">
  <style>
    body { font-family: Verdana,Tahoma,Arial,Helvetica; font-size:9pt}
    .header { font-size: 16pt; font-weight: 900; }
  </style>
</head>
<body bgcolor="#ffffff" topMargin='5'>

<span class='header'>$svrname RRD Status :: $descr</span>
<br><br>
END
;

if ($name eq '')
{
	print "Daily Graphs (5 minute averages)";
	print "<br>";

	foreach $graph (@graphs)
	{
		print "<a href='?trend=$graph'><img src='$img_path/$graph-day.png' border='1'></a>";
		print "<br>";
	}
}
else
{
	print <<END

Daily Graph (5 minute averages)
<br>
<img src='$img_path/$name-day.png'>
<br>
Weekly Graph (30 minute averages)
<br>
<img src='$img_path/$name-week.png'>
<br>
Monthly Graph (2 hour averages)
<br>
<img src='$img_path/$name-month.png'>
<br>
Yearly Graph (12 hour averages)
<br>
<img src='$img_path/$name-year.png'>
END
;
}

print <<END
<br><br>
<a href='http://ee-staff.ethz.ch/~oetiker/webtools/rrdtool/'>
 <img src='http://people.ee.ethz.ch/~oetiker/webtools/rrdtool/.pics/rrdtool.gif' border='0'></a>
</body>
</html>
END
;
